ASTR macro args:VARARG
	LOCAL sym
	data segment
		ifidni <args>,<>
			sym db 0
		else
			sym db args,0
		endif
	data ends
	exitm <offset sym>
endm

cSEH = 0 ;_try_catch_finally counter
_try macro cNested
	LOCAL lbl
	
	ifnb <cNested>
		lbl textequ @CatStr(__finally,%(cSEH),_,%(cNested))
	else
		lbl textequ @CatStr(__finally,%(cSEH))
	endif
	push lbl	 		;address of safe place after guarded code
	
	push ebp 			;stackframe
	push esp
	
	assume fs:nothing
	
	ifnb <cNested>
		lbl textequ @CatStr(__catch,%(cSEH),_,%(cNested))
	else
		lbl textequ @CatStr(__catch,%(cSEH))
	endif
	push lbl	 		;address of frame-based Exceptionhandler
	
	push fs:[0]			;address of next error structure
	mov fs:[0],esp 		;save the error address
endm

_catch macro cNested ;eax = pointer to EXCEPTION_RECORD struct
    local lbl
    
    add esp,12
	ifnb <cNested>
		lbl textequ @CatStr(__finally,%(cSEH),_,%(cNested))
	else
		lbl textequ @CatStr(__finally,%(cSEH))
	endif
	jmp lbl
	
	ifnb <cNested>
		lbl textequ @CatStr(__catch,%(cSEH),_,%(cNested))
	else
		lbl textequ @CatStr(__catch,%(cSEH))
	endif
	lbl:
	
	push ebp
	mov ebp,esp
	push edi
	push esi
	push edx
	mov eax,dword ptr [ebp+8] ;pExceptionRecord
endm

_finally macro cNested
	LOCAL lbl
	
	mov eax,dword ptr [ebp+12] 	;pStackFrame
	push dword ptr [eax+8]		; PrevEsp
	push dword ptr [eax+12]		; PrevEbp
	push dword ptr [eax+16]		; SafeOffset
	
	mov eax,dword ptr [ebp+16] 	;pContext
	pop [eax].CONTEXT.regEip			;SafeOffset
	pop [eax].CONTEXT.regEbp			;PrevEbp
	pop [eax].CONTEXT.regEsp			;PrevEsp
	
 	pop edx
	pop esi
    pop edi
    
    mov esp,ebp
    pop ebp
   	xor eax, eax 
    retn 24h
    
	ifnb <cNested>
		lbl textequ @CatStr(__finally,%(cSEH),_,%(cNested))
	else
		lbl textequ @CatStr(__finally,%(cSEH))
		cSEH = cSEH + 1
	endif
	lbl:
	
	assume fs:nothing
	pop fs:[0] ; restore
	add esp,4 
endm
